Module Module1

  Sub Main()
    Dim nNumVars As Integer = 2
    Dim fX() As Double = {0, 0}
    Dim fParam() As Double = {0, 0}
    Dim fStepSize() As Double = {0.1, 0.1}
    Dim fMinStepSize() As Double = {0.00001, 0.00001}
    Dim nIter As Integer = 0
    Dim I As Integer
    Dim fBestF As Double
    Dim sAnswer As String
    Dim oOpt As CDirectSearch
    Dim MyFx As MyFxDelegate = AddressOf Fx1
    Dim SayFx As SayFxDelegate = AddressOf SayFx1

    oOpt = New CDirectSearch

    Console.WriteLine("Direct Search Optimization")
    Console.WriteLine("Finding the minimu of function:")
    Console.WriteLine(SayFx())
    Console.Write("Use default input values? (Y/N) ")
    sAnswer = Console.ReadLine()
    If sAnswer.ToUpper() = "Y" Then
      For I = 0 To nNumVars - 1
        Console.WriteLine("X({0}) = {1}", I + 1, fX(I))
        Console.WriteLine("Step Size({0}) = {1}", I + 1, fStepSize(I))
        Console.WriteLine("Min Step Size({0}) = {1}", I + 1, fMinStepSize(I))
      Next
    Else
      For I = 0 To nNumVars - 1
        fX(I) = GetIndexedDblInput("X", I + 1, fX(I))
        fStepSize(I) = GetIndexedDblInput("Initial step size(", I + 1, fStepSize(I))
        fMinStepSize(I) = GetIndexedDblInput("Minimum step size", I + 1, fMinStepSize(I))
      Next
    End If

    Console.WriteLine("******** FINAL RESULTS *************")
    fBestF = oOpt.DirectSearch(nNumVars, fX, fParam, fStepSize, fMinStepSize, nIter, MyFx)
    Console.WriteLine("Optimum at")
    For I = 0 To nNumVars - 1
      Console.WriteLine("X({0}) = {1}", I + 1, fX(I))
    Next
    Console.WriteLine("Function value = {0}", fBestF)
    Console.WriteLine("Number of iterations = {0}", nIter)
    Console.WriteLine()
    Console.Write("Press Enter to end the program ...")
    Console.ReadLine()
  End Sub

  Function GetDblInput(ByVal sPrompt As String, ByVal fDefInput As Double) As Double
    Dim sInput As String

    Console.Write("{0}? ({1}): ", sPrompt, fDefInput)
    sInput = Console.ReadLine()
    If sInput.Trim().Length > 0 Then
      Return Double.Parse(sInput)
    Else
      Return fDefInput
    End If
  End Function

  Function GetIndexedDblInput(ByVal sPrompt As String, ByVal nIndex As Integer, ByVal fDefInput As Double) As Double
    Dim sInput As String

    Console.Write("{0}({1})? ({2}): ", sPrompt, nIndex, fDefInput)
    sInput = Console.ReadLine()
    If sInput.Trim().Length > 0 Then
      Return Double.Parse(sInput)
    Else
      Return fDefInput
    End If
  End Function

  Function SayFx1() As String
    Return "F(X) = 10 + (X(1) - 2) ^ 2 + (X(2) + 5) ^ 2"
  End Function

  Function Fx1(ByVal N As Integer, ByRef X() As Double, ByRef fParam() As Double) As Double
    Return 10 + (X(0) - 2) ^ 2 + (X(1) + 5) ^ 2
  End Function

  Function SayFx2() As String
    Return "F(X) = 100 * (X(1) - X(2) ^ 2) ^ 2 + (X(2) - 1) ^ 2"
  End Function

  Function Fx2(ByVal N As Integer, ByRef X() As Double, ByRef fParam() As Double) As Double
    Return 100 * (X(0) - X(1) ^ 2) ^ 2 + (X(1) - 1) ^ 2
  End Function

  Function SayFx3() As String
    Return "F(X) = X(1) - X(2) + 2 * X(1) ^ 2 + 2 * X(1) * X(2) + X(2) ^ 2"
  End Function

  Function Fx3(ByVal N As Integer, ByRef X() As Double, ByRef fParam() As Double) As Double
    Return X(0) - X(1) + 2 * X(0) ^ 2 + 2 * X(0) * X(1) + X(1) ^ 2
  End Function

  Function SayFxFit() As String
    Return "Fitting Yd = 11 - 10 * Exp(-0.75 * Xd) + 8 * Exp(-0.35 * Xd)"
  End Function

  Function FxFit(ByVal N As Integer, ByRef X() As Double, ByRef fParam() As Double) As Double
    Const M = 100

    Dim I As Integer
    Dim Xd, Yd, Yd2, SumSqr As Double

    SumSqr = 0
    For I = 0 To M - 1
      Xd = 0.1 * (I + 1)
      Yd = 11 - 10 * Math.Exp(-0.75 * Xd) + 8 * Math.Exp(-0.35 * Xd)
      Yd2 = X(0) - X(1) * Math.Exp(-X(2) * Xd) + X(3) * Math.Exp(-X(4) * Xd)
      SumSqr = SumSqr + (Yd - Yd2) ^ 2
    Next I
    Return SumSqr
  End Function
End Module
